<template>
  <div class="container_warp">
    <!-- <button @click="copy">copy</button> -->
    <div class="operating">
      <div class="top">
        <div class="btn-group">
          <Tooltip content="直线箭头" placement="bottom">
            <div
              :class="['btn', currentArrow === 1 ? 'currentArrow' : '']"
              @click="changeEdgeType('normal')"
            >
              <i class="iconfont icon-ai28"></i>
            </div>
          </Tooltip>
          <Tooltip content="曲线箭头" placement="bottom">
            <div
              :class="['btn', currentArrow === 2 ? 'currentArrow' : '']"
              @click="changeEdgeType('smooth')"
            >
              <i class="iconfont icon-Down-Right"></i>
            </div>
          </Tooltip>
          <Tooltip content="直角箭头" placement="bottom">
            <div
              :class="['btn', currentArrow === 3 ? 'currentArrow' : '']"
              @click="changeEdgeType()"
            >
              <i class="iconfont icon-jiantou"></i>
            </div>
          </Tooltip>
        </div>
        <div class="btn-group">
          <Tooltip content="删除" placement="bottom">
            <div class="btn" @click="deleteNode()" style="margin-top: 5px">
              <i class="iconfont icon-shanchu"></i>
            </div>
          </Tooltip>
          <Tooltip content="保存PNG" placement="bottom">
            <div class="btn" @click="saveToPNG()" title="保存">
              <i class="iconfont icon-baocun"></i>
            </div>
          </Tooltip>
          <Tooltip content="保存Json" placement="bottom">
            <div class="btn" @click="saveToJson()" title="保存">
              <i class="iconfont icon-baocun"></i>
            </div>
          </Tooltip>
          <Tooltip content="保存至云端" placement="bottom">
            <div class="btn" @click="saveProj()" title="保存">
              <i class="iconfont icon-baocun"></i>
            </div>
          </Tooltip>
        </div>
      </div>
      <div class="base-graph">
        <div class="note">基础模块</div>
        <div class="content">
          <div
            class="btn"
            @mousedown="startDrag(item.nodetype, $event)"
            v-for="(item, index) of def_list"
            :key="item.module_def_id"
          >
            {{ item.module_def_name }}
          </div>
          <!-- <div
            class="btn"
            title="卷积层"
            @mousedown="startDrag(nodetype1, $event)"
          >
            conv_layer
          </div>
          <div
            class="btn"
            title="池化层"
            @mousedown="startDrag(nodetype2, $event)"
          >
            pooling_layer
          </div>
          <div
            class="btn"
            title="激活函数"
            @mousedown="startDrag(nodetype3, $event)"
          >
            activate_function
          </div>
          <div
            class="btn"
            title="全连接函数"
            @mousedown="startDrag(nodetype4, $event)"
          >
            fc_layer
          </div> -->
        </div>
        <!-- <div class="btn-group_tips" v-if="showTips">
          拖拽生成<br />深度神经网络
        </div> -->
      </div>
      <div class="base-graph">
        <div class="note">自定义模块</div>
        <div class="content">
          <div
            class="btn"
            @mousedown="startDrag(custom_type, $event, mymodule.module_list)"
            v-for="(mymodule, index) of custom_list"
            :key="index"
          >
            {{ mymodule.name }}
          </div>
        </div>
        <!-- <div class="btn-group_tips" v-if="showTips">
          拖拽生成<br />深度神经网络
        </div> -->
      </div>
    </div>
    <div id="containerChart"></div>
    <!-- <div id="minimap"></div> -->
    <div id="mycontextMenu" ref="mycontextMenu">
      <ul>
        <li @click="copy">复制</li>
        <li @click="paste">粘贴</li>
        <li @click="combination">自定义模块</li>
      </ul>
    </div>
    <RightDrawer
      class="right_drawer"
      :LayerType="LayerType"
      :drawerType="type"
      :selectCell="selectCell"
      :graph="graph"
      :grid="grid"
      @deleteNode="deleteNode"
    ></RightDrawer>
  </div>
</template>

<script>
import "@antv/x6-vue-shape";
import {
  Graph,
  Shape,
  Addon,
  FunctionExt,
  DataUri,
  minimapContainer,
} from "@antv/x6";
import RightDrawer from "../components/RightDrawer";
import insertCss from "insert-css";
import { startDragToGraph } from "./Graph/methods.js";
import { reqProjInfo } from "@/api";
import "@/assets/iconfont.css";
import {
  reqGetDefList,
  reqAddCustomModulem,
  reqGetCustomModule,
  reqSaveStructure,
} from "@/api/index";
// const data = {};
export default {
  data() {
    return {
      graph: "",
      graph_data: "",
      custom_list: [], //add by waq 自定义模块的列表
      def_list: [],
      mymodule_cnt: 0,
      mycell_cnt: 0,
      value1: true,
      type: "grid",
      LayerType: "conv_layer",
      selectCell: "",
      nodetype1: { type: "Rect", text: "conv_layer" },
      nodetype2: { type: "Rect", text: "pooling_layer" },
      nodetype3: { type: "Rect", text: "activate_function" },
      nodetype4: { type: "Rect", text: "fc_layer" },
      custom_type: { type: "custom_shape", text: "custom_layer" },
      connectEdgeType: {
        //连线方式
        connector: "normal",
        router: {
          name: "",
        },
      },
      showTips: false,
      currentArrow: 1,
      grid: {
        // 网格设置
        size: 20, // 网格大小 10px
        visible: true, // 渲染网格背景
        type: "mesh",
        args: {
          color: "#D0D0D0",
          thickness: 1, // 网格线宽度/网格点大小
          factor: 10,
        },
      },
    };
  },
  components: {
    RightDrawer,
  },
  methods: {
    initX6() {
      var _that = this;
      this.graph = new Graph({
        container: document.getElementById("containerChart"),
        width: 1700,
        height: "100%",
        grid: _that.grid,
        resizing: {
          //调整节点宽高
          enabled: true,
          orthogonal: false,
        },
        selecting: {
          enabled: true,
          rubberband: true,
          rubberEdge: true,
          showNodeSelectionBox: true,
        }, //可选
        snapline: true,
        interacting: {
          edgeLabelMovable: true,
        },
        connecting: {
          // 节点连接
          anchor: "center",
          connectionPoint: "anchor",
          allowBlank: false,
          snap: true,
          createEdge() {
            return new Shape.Edge({
              attrs: {
                line: {
                  stroke: "#1890ff",
                  strokeWidth: 1,
                  targetMarker: {
                    name: "classic",
                    size: 8,
                  },
                  strokeDasharray: 0, //虚线
                  style: {
                    animation: "ant-line 30s infinite linear",
                  },
                },
              },
              label: {
                text: "",
              },
              connector: _that.connectEdgeType.connector,
              router: {
                name: _that.connectEdgeType.router.name || "",
              },
              zIndex: 0,
            });
          },
        },
        highlighting: {
          magnetAvailable: {
            name: "stroke",
            args: {
              padding: 4,
              attrs: {
                strokeWidth: 4,
                stroke: "#6a6c8a",
              },
            },
          },
        },
        //剪切板
        clipboard: true,
        keyboard: true,
        mousewheel: {
          enabled: true,
        },
        // history: true,
        // minimap: {
        //   enabled: true,
        //   container: document.getElementById("minimap"),
        // },
      });
      insertCss(`
            @keyframes ant-line {
              to {
                  stroke-dashoffset: -1000
              }
            }
          `);
      console.log("this.graph_data1", this.graph_data);
      this.graph.fromJSON(JSON.parse(this.graph_data));
      this.graph.history.redo();
      this.graph.history.undo();
      // 键盘事件：cv，delete
      this.graph.bindKey("delete", this.deleteNode);
      this.graph.bindKey("ctrl+c", this.copy);
      this.graph.bindKey("ctrl+v", this.paste);
      this.graph.bindKey("ctrl+s", this.saveProj);
      // 鼠标移入移出节点
      this.graph.on(
        "node:mouseenter",
        FunctionExt.debounce(() => {
          const container = document.getElementById("containerChart");
          const ports = container.querySelectorAll(".x6-port-body");
          this.showPorts(ports, true);
        }),
        500
      );
      this.graph.on("node:added", ({ node }) => {
        // console.log('node:added',node,node.store.data.position)
        // console.log("data",node.attrs.data)
        if (node.attrs.label.text === "custom_layer") {
          // 计算位移
          // 理论上长度至少为2
          const base = node.attrs.data[0];
          for (const mycells of node.attrs.data) {
            if (mycells.shape !== "edge") {
              mycells.dis_list = {
                x: mycells.position.x - base.position.x,
                y: mycells.position.y - base.position.y,
              };
            }
          }
          //增加节点
          for (const mycells of node.attrs.data) {
            // 设置新id 不然会跟原来的重复
            mycells.id = mycells.id + "" + this.mycell_cnt;
            if (mycells.shape === "edge") {
              // 设置edge两端的新id 不然会跟原来的重复
              mycells.source.cell = mycells.source.cell + "" + this.mycell_cnt;
              mycells.target.cell = mycells.target.cell + "" + this.mycell_cnt;
              // 设置为实线
              mycells.attrs.line.strokeDasharray = 0;
              this.graph.addEdge(mycells);
            } else {
              mycells.position = {
                x: node.store.data.position.x + mycells.dis_list.x,
                y: node.store.data.position.y + mycells.dis_list.y,
              };
              this.graph.addNode(mycells);
            }
          }
          this.graph.removeNode(node);
          this.mycell_cnt++;
          // this.graph.fromJSON(mydata)
        }
      });
      this.graph.on("node:mouseleave", () => {
        const container = document.getElementById("containerChart");
        const ports = container.querySelectorAll(".x6-port-body");
        this.showPorts(ports, false);
      });
      this.graph.on("blank:click", () => {
        this.type = "grid";
        this.$refs.mycontextMenu.style.left = -100 + "px";
      });
      this.graph.on("cell:click", ({ cell }) => {
        console.log("cell", cell);
        this.type = cell.isNode() ? "node" : "edge";
        if (cell.isNode()) this.LayerType = cell.attrs.data.type;
        this.$refs.mycontextMenu.style.left = -100 + "px";
      });
      this.graph.on("cell:contextmenu", (event) => {
        this.$refs.mycontextMenu.style.left = 230 + event.x + "px";
        this.$refs.mycontextMenu.style.top = event.y + "px";
      });
      this.graph.on("blank:contextmenu", (event) => {
        this.$refs.mycontextMenu.style.left = 230 + event.x + "px";
        this.$refs.mycontextMenu.style.top = event.y + "px";
      });
      this.graph.on("selection:changed", (args) => {
        args.added.forEach((cell) => {
          this.selectCell = cell;
          if (cell.isEdge()) {
            cell.isEdge() && cell.attr("line/strokeDasharray", 5); //虚线蚂蚁线
            cell.addTools([
              {
                name: "vertices",
                args: {
                  padding: 4,
                  attrs: {
                    strokeWidth: 0.1,
                    stroke: "#2d8cf0",
                    fill: "#ffffff",
                  },
                },
              },
            ]);
          }
        });
        args.removed.forEach((cell) => {
          cell.isEdge() && cell.attr("line/strokeDasharray", 0); //正常线
          cell.removeTools();
        });
      });
    },
    showPorts(ports, show) {
      for (let i = 0, len = ports.length; i < len; i = i + 1) {
        ports[i].style.visibility = show ? "visible" : "hidden";
      }
    },
    // 拖拽生成正方形或者圆形
    startDrag(type, e, json_data) {
      this.LayerType = type.text;
      startDragToGraph(this.graph, type, e, json_data);
    },
    saveToJson() {
      this.$nextTick(() => {
        const getJson = this.graph.toJSON();
        console.log("getJson", getJson);
        let data = JSON.stringify(getJson);
        let uri =
          "data:text/csv;charset=utf-8,\ufeff" + encodeURIComponent(data);
        let link = document.createElement("a");
        link.href = uri;
        link.download = "save.json";
        document.body.appendChild(link);
        link.click();
        document.body.removeChild(link);
      });
    },

    // 删除节点
    deleteNode() {
      const cell = this.graph.getSelectedCells();
      this.graph.removeCells(cell);
      this.type = "grid";
    },
    // 保存png
    saveToPNG() {
      this.$nextTick(() => {
        this.graph.toPNG(
          (dataUri) => {
            // 下载
            DataUri.downloadDataUri(dataUri, "Neural Networks.png");
          },
          {
            backgroundColor: "white",
            padding: {
              top: 50,
              right: 50,
              bottom: 50,
              left: 50,
            },
            quality: 1,
            copyStyles: false,
          }
        );
      });
    },
    // 改变边形状
    changeEdgeType(e) {
      if (e === "normal") {
        this.connectEdgeType = {
          connector: "normal",
          router: { name: "" },
        };
        this.currentArrow = 1;
      } else if (e === "smooth") {
        this.connectEdgeType = {
          connector: "smooth",
          router: { name: "" },
        };
        this.currentArrow = 2;
      } else {
        this.connectEdgeType = {
          connector: "normal",
          router: { name: "manhattan" },
        };
        this.currentArrow = 3;
      }
    },
    // NodeConfig(){
    // Shape.Rect.config({
    //   width: 80,
    //   height: 40,
    //   attrs: {
    //   },
    //   data: {
    //     type:"",//结点类型
    //     in_channels: 1, //进通道数
    //     out_channels: 1,//出通道数
    //     kernel_size:3, //卷积核数
    //     stride:3, //卷积核每步移动的距离
    //     padding:0, //填充像素点框
    //     in_features:0,
    //     out_features:0,
    //   },
    // })
    // },

    //获取选中区域所有元素的json字符串，以列表格式返回
    getSelectJsonList() {
      let ret = [];
      this.graph.getSelectedCells().forEach((item) => {
        ret.push(item.toJSON());
      });
      console.log("getSelectJsonList", ret);
      return ret;
    },
    copy() {
      this.graph.copy(this.graph.getSelectedCells());
      this.$refs.mycontextMenu.style.left = -100 + "px";
    },
    paste() {
      this.graph.resetSelection(
        this.graph.paste({
          offset: 20,
        })
      );
      this.$refs.mycontextMenu.style.left = -100 + "px";
    },
    combination() {
      this.$refs.mycontextMenu.style.left = -100 + "px";
      const ret = this.getSelectJsonList();
      if (ret.length > 1) {
        this.custom_list.push({
          name: `custom_module${this.mymodule_cnt}`,
          module_list: ret,
        });
        console.log("ret1", ret);
        this.mymodule_cnt++;
        const mystruct = [];
        let module_custom_param_num = 0;
        for (const item of ret) {
          if (item.shape === "edge") continue;
          console.log("item1", item);
          const module_param_list = [];
          for (const key of Object.keys(item.attrs.data)) {
            if (key !== "module_def_id") {
              module_param_list.push(item.attrs.data[key]);
              module_custom_param_num++;
            }
          }
          console.log("key-values", module_param_list);

          mystruct.push({
            module_id: item.attrs.data.module_def_id,
            module_is_custom: false,
            module_param_list: module_param_list,
          });
          console.log("item", item);
        }
        let params = {
          module_custom_user_id: this.$store.state.login.LoginData.user_id,
          module_custom_name: `custom_module${this.mymodule_cnt}`,
          module_custom_desc: "",
          module_custom_structure: mystruct,
          module_custom_param_num: module_custom_param_num,
          module_custom_json: JSON.stringify(ret),
        };
        console.log("before await", params);
        reqAddCustomModule(params)
          .then((value) => {
            console.log("in combination value:", value);
          })
          .catch((error) => {
            console.log("in combination error:", error);
          });
      } else {
        console.log("数量不足，不可以组合");
      }
    },
    saveProj() {
      const getJson = this.graph.toJSON();
      console.log("getJson", getJson);
      let cells = this.graph.getCells();
      let len = cells.length;
      let formDatas = {};
      formDatas["project_id"] = this.$route.query.proj_id;
      formDatas["project_structure"] = [];
      formDatas["project_json"] = JSON.stringify(getJson);
      let project_structures = [];
      for (let i = 0; i < len; i++) {
        if (cells[i].shape == "edge") continue;
        let project_structure = {};
        project_structure["layer_id"] = cells[i].attrs.data.layer_id;
        project_structure["layer_is_custom"] = false;
        project_structure["layer_is_new"] = true;
        project_structure["layer_x"] = 0;
        project_structure["layer_y"] = 0;
        project_structure["layer_param_num"] = 9;
        project_structure["layer_param_list"] = [
          cells[i].attrs.data.ActFunc,
          cells[i].attrs.data.in_channels,
          cells[i].attrs.data.in_features,
          cells[i].attrs.data.kernel_size,
          cells[i].attrs.data.out_channels,
          cells[i].attrs.data.out_features,
          cells[i].attrs.data.padding,
          cells[i].attrs.data.stride,
        ];
        project_structure["layer_module_id"] =
          cells[i].attrs.data.module_def_id;
        project_structures.push(project_structure);
      }
      formDatas["project_structure"] = project_structures;
      console.log("formDatas", formDatas);
      reqSaveStructure(formDatas)
        .then((res) => {
          // let cells = this.graph.getCells()
          for (let i = 0; i < cells.length; i++) {
            if (cells[i].attrs.data.layer_id != -1) continue;
            else {
              cells[i].attrs.data.layer_id = res["project_layer_lst"][i];
            }
          }
          console.log("ok");
        })
        .catch((err) => {
          console.log("in reqSaveStructure error:", error);
        });
    },
  },
  computed: {},
  mounted() {
    let proj_id = this.$route.query.proj_id;
    this.proj_id = proj_id;
    console.log(proj_id);
    reqProjInfo({
      proj_id: proj_id,
    })
      .then((res) => {
        // console.log("res['project_json']",res)
        this.graph_data = res["project_json"] || "{}";
        console.log("this.graph_data", this.graph_data);
        this.initX6();
        let cells = this.graph.getCells();
        console.log("cells", cells, "this.$route.params", this.$route.params);
        for (let i = 0; i < cells.length; i++) {
          cells[i].attrs.data.layer_id = this.$route.params.proj_structure[i];
        }
        // this.NodeConfig()
        setTimeout(() => {
          this.showTips = true;
        }, 1000);
        setTimeout(() => {
          this.showTips = false;
        }, 5000);
        console.log("正确返回", res);
      })
      .catch((err) => {
        this.initX6();
        console.log("错误返回", err);
      });
    reqGetDefList()
      .then((value) => {
        console.log("value", value);
        for (const item of value.def_data) {
          item.nodetype = {
            type: "Rect",
            text: item.module_def_name,
            module_def_id: item.module_def_id,
            layer_id: -1,
          };
          this.def_list.push(item);
        }
        console.log("value", value);
      })
      .catch((error) => {
        console.log("error", error);
      });
    reqGetCustomModule()
      .then((value) => {
        console.log("in reqGetCustomModule suc", value);
        for (const item of value.cos_data) {
          console.log("in req item :", {
            name: item.module_custom_name,
            module_list: item.module_custom_json,
          });
          this.custom_list.push(
            {
              name: item.module_custom_name,
              module_list: JSON.parse(item.module_custom_json),
            } //?
          );
        }
      })
      .catch((error) => {
        console.log("in reqGetCustomModule err", err);
      });
  },
};
</script>
<style lang="scss">
.container_warp {
  position: relative;
  width: 100%;
  height: 100vh;
  display: flex;
  .operating {
    // position: relative;
    flex-shrink: 0;
    width: 230px;
    height: 100%;
    background-color: #ffffff;
    padding: 20px 10px;
    box-shadow: 1px 1px 4px 0 #0a0a0a2e;
    display: flex;
    flex-direction: column;
    .top {
      margin-bottom: 20px;
      flex-basis: 70px;
      display: flex;
      flex-direction: column;
      align-items: center;
      .btn-group {
        border-right: 1px solid #efefef;
        display: inline-block;
        padding-left: 10px;
        padding-right: 14px;
        position: relative;
        width: 100%;
        display: flex;
        justify-content: space-around;
        .btn-group_tips {
          text-align: center;
          top: 63px;
          left: 1px;
          position: absolute;
          color: #fff;
          display: flex;
          align-items: center;
          justify-content: center;
          width: 120px;
          height: 60px;
          background: #515a6e;
          border-radius: 6px;
          animation: tips 4s;
          transition: all 1s;
          &:after {
            content: "";
            width: 0;
            height: 0;
            position: absolute;
            top: -5px;
            left: 46%;
            border-width: 0 5px 5px;
            border-style: solid;
            border-color: transparent transparent #515a6e;
          }
        }
        &:last-of-type {
          border-right: 0;
        }
        .btn {
          display: inline-block;
          margin: 2px;
          width: 30px;
          height: 30px;
          line-height: 30px;
          text-align: center;
          cursor: pointer;
          transition: all 0.4s;
          border-radius: 6px;
          border: 1px solid rgba(233, 233, 233, 0);
          i {
            font-size: 20px;
          }
        }
        .currentArrow {
          background: #2d8cf0;
          color: #fff;
        }
      }
    }
    .base-graph {
      border-top: 2px solid #ccc;
      padding: 5px;
      // background-color: blue;
      .note {
        margin: 10px 0;
        font-size: 1.5rem;
      }
      .content {
        display: flex;
        flex-wrap: wrap;
        justify-content: space-between;
        .btn {
          width: 90px;
          height: 60px;
          margin: 2px;
          cursor: pointer;
          transition: all 0.4s;
          border-radius: 2px;
          border: 1.5px solid black;
          margin-bottom: 15px;
          font-size: 1rem;
          display: flex;
          justify-content: center;
          align-items: center;
          word-break: break-all;
          padding: 0 8px;
        }
      }
    }
    .user-graph {
      border-top: 2px solid #ccc;
      // background-color: pink;
    }
  }
  // #minimap {
  //   position: absolute;
  //   background-color: pink;
  //   width: 300px;
  //   height: 300px;
  // }
}
@keyframes tips {
  0% {
    opacity: 0;
    transform: scale(0);
  }
  10% {
    opacity: 1;
    transform: scale(1);
  }
  90% {
    opacity: 1;
    transform: scale(1);
  }
  100% {
    opacity: 0;
    transform: scale(0);
  }
}
.rotate-square {
  display: inline-block;
  transform: rotate(45deg);
}
.my-snapline {
  color: #000;
}
.right_drawer {
  height: 100%;
  width: 300px;
  border-left: 1px solid #eee;
  background: #fff;
}
#mycontextMenu {
  position: absolute;
  left: -100px;
  ul {
    border: 1px solid #e4e7ed;
    border-radius: 4px;
    background-color: #fff;
    box-shadow: 0 2px 12px 0 rgba(0, 0, 0, 0.1);
    box-sizing: border-box;
    margin: 5px 0;
    padding: 6px 0;

    li {
      font-size: 14px;
      padding: 0 20px;
      position: relative;
      white-space: nowrap;
      overflow: hidden;
      text-overflow: ellipsis;
      color: #606266;
      height: 34px;
      line-height: 34px;
      box-sizing: border-box;
      cursor: pointer;

      &:hover {
        background-color: #f5f7fa;
      }
    }
  }
}
</style>